SystemOrganization addCategory: #ProyectoFinalTest!
SystemOrganization addCategory: #'ProyectoFinalTest-Ordenes1'!

Object subclass: #FabricaEmisores
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinalTest'!

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:26'!
EM1
	| em1 |
	em1 := Issuer
		name: 'Betiana'
		lastName: 'Rocha'
		DNI: '24356890'
		CUIT: '30-24356890-0'
		address: 'Alsina 125'.
	^ em1! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:27'!
EM10
	| em10 |
	em10 := Issuer
		name: 'Vanesa'
		lastName: 'Colinos'
		DNI: '20198735'
		CUIT: '30-20198735-9'
		address: 'Ruta 2 Km 11'.
	^ em10! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:28'!
EM11
	| em11 |
	em11 := Issuer
		name: 'Arnaldo'
		lastName: 'Jimenez'
		DNI: '25698452'
		CUIT: '30-25698452-8'
		address: 'Costanera 120'.
	^ em11! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:28'!
EM12
	| em12 |
	em12 := Issuer
		name: 'Alejandra'
		lastName: 'Rodriguez'
		DNI: '14742569'
		CUIT: '30-14742569-3'
		address: 'Grecia 125'.
	^ em12! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:42'!
EM13
	| em13 |
	em13 := Issuer
		conNombre: 'Ernesto'
		conApellido: 'Gilera'
		conDNI: '13587258'
		conCUIT: '30-13587258-6'
		conDireccion: 'Moldavia 5879'.
	^ em13! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:29'!
EM2
	| em2 |
	em2 := Issuer
		name: 'Cristian'
		lastName: 'Cemero'
		DNI: '23587458'
		CUIT: '30-23587458-6'
		address: 'Santa Fe 4587'.
	^ em2! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:29'!
EM3
	| em3 |
	em3 := Issuer
		name: 'Laura'
		lastName: 'Pozzi'
		DNI: '23698547'
		CUIT: '30-23698547-4'
		address: 'Libertador 2359'.
	^ em3! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:29'!
EM4
	| em4 |
	em4 := Issuer
		name: 'Juan Jos'
		lastName: 'Lopez'
		DNI: '19587235'
		CUIT: '30-19587235-3'
		address: 'Avenida 7 568'.
	^ em4! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:30'!
EM5
	| em5 |
	em5 := Issuer
		name: 'Cintia'
		lastName: 'Castaa'
		DNI: '18578214'
		CUIT: '30-18578214-3'
		address: 'Calle 46 1254'.
	^ em5! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:32'!
EM6
	| em6 |
	em6 := Issuer
		name: 'Daniel'
		lastName: 'Gonzales'
		DNI: '17587402'
		CUIT: '30-17587402-3'
		address: 'Montevideo 1586'.
	^ em6! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:33'!
EM7
	| em7 |
	em7 := Issuer
		name: 'Ral'
		lastName: 'Saporiti'
		DNI: '29875421'
		CUIT: '30-29875421-2'
		address: 'Calle 19 258'.
	^ em7! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:34'!
EM8
	| em8 |
	em8 := Issuer
		name: 'Anselmo'
		lastName: 'Bartoloti'
		DNI: '30254139'
		CUIT: '30-30254139-5'
		address: 'Belgrano 1202'.
	^ em8! !

!FabricaEmisores methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:34'!
EM9
	| em9 |
	em9 := Issuer
		name: 'Mara Jos'
		lastName: 'Molinos'
		DNI: '25789143'
		CUIT: '30-25789143-5'
		address: 'Centenario 254'.
	^ em9! !

Object subclass: #FabricaOrdenesD1
	instanceVariableNames: 'fabricaEmisores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinalTest-Ordenes1'!

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 21:39'!
OC1
	| orden |
	orden := PurchaseOrder
		bid: 1
		price: 25
		date: (Date year: 2012 month: 1 day: 1)
		issuer: fabricaEmisores EM1
		receivingAddress: 'Puerto Madero'
		shippingMethod: 'Barco'.
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OC2
	| orden | 
	orden := PurchaseOrder
		conEmisor: fabricaEmisores EM2
		conCantidad: 2
		conPrecioTotal: 60
		conFecha: (Date year: 2012 month: 1 day: 2).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OC3
	| orden | 
	orden := PurchaseOrder
		conEmisor: fabricaEmisores EM3
		conCantidad: 2
		conPrecioTotal: 50
		conFecha: (Date year: 2012 month: 1 day: 7).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OC4
	| orden |
	orden := PurchaseOrder
		conEmisor: fabricaEmisores EM4
		conCantidad: 3
		conPrecioTotal: 90
		conFecha: (Date year: 2012 month: 1 day: 8).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OC5
	| orden |
	orden := PurchaseOrder
		conEmisor: fabricaEmisores EM5
		conCantidad: 4
		conPrecioTotal: 160
		conFecha: (Date year: 2012 month: 1 day: 9).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OC6
	| orden | 
	orden := PurchaseOrder
		conEmisor: fabricaEmisores EM6
		conCantidad: 10
		conPrecioTotal: 200
		conFecha: (Date year: 2012 month: 1 day: 3).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 21:40'!
OV1
	| orden |
	orden := SalesOrder
		ask: 2
		price: 50
		date: (Date year: 2012 month: 1 day: 4)
		issuer: fabricaEmisores EM7
		paymentMethod: 'Cheque'
		availabilityDate: (Date year: 2012 month: 2 day: 1).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OV2
	| orden | 
	orden := SalesOrder
		conEmisor: fabricaEmisores EM8
		conCantidad: 1
		conPrecioTotal: 25
		conFecha: (Date year: 2012 month: 1 day: 11).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OV3
	| orden fabricaEmisores | 
	fabricaEmisores := FabricaEmisores new.
	orden := SalesOrder
		conEmisor: fabricaEmisores EM9
		conCantidad: 3
		conPrecioTotal: 75
		conFecha: (Date year: 2012 month: 1 day: 12).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OV4
	| orden fabricaEmisores | 
	fabricaEmisores := FabricaEmisores new.
	orden := SalesOrder
		conEmisor: fabricaEmisores EM10
		conCantidad: 3
		conPrecioTotal: 180
		conFecha: (Date year: 2012 month: 1 day: 10).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OV5
	| orden fabricaEmisores |
	fabricaEmisores := FabricaEmisores new.
	orden := SalesOrder
		conEmisor: fabricaEmisores EM11
		conCantidad: 1
		conPrecioTotal: 60
		conFecha: (Date year: 2012 month: 1 day: 5).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OV6
	| orden fabricaEmisores | 
	fabricaEmisores := FabricaEmisores new.
	orden := SalesOrder
		conEmisor: fabricaEmisores EM12
		conCantidad: 2
		conPrecioTotal: 80
		conFecha: (Date year: 2012 month: 1 day: 6).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 19:01'!
OV7
	| orden fabricaEmisores | 
	fabricaEmisores := FabricaEmisores new.
	orden := SalesOrder
		conEmisor: fabricaEmisores EM13
		conCantidad: 2
		conPrecioTotal: 60
		conFecha: (Date year: 2012 month: 1 day: 13).
	^ orden! !

!FabricaOrdenesD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:16'!
initialize
	fabricaEmisores := FabricaEmisores new! !

TestCase subclass: #OrderBookTestD1
	instanceVariableNames: 'orderBook1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinalTest-Ordenes1'!

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:38'!
setUp
	orderBook1 := (OrderBook new).
	orderBook1
		addOrder: (Order bid: 4 price: 40);
		addOrder: (Order bid: 3 price: 30);
		addOrder: (Order bid: 2 price: 30);
		addOrder: (Order bid: 2 price: 25);
		addOrder: (Order bid: 1 price: 25);
		addOrder: (Order bid: 10 price: 20);										
		addOrder: (Order ask: 1 price: 25);
		addOrder: (Order ask: 2 price: 25);
		addOrder: (Order ask: 3 price: 25);
		addOrder: (Order ask: 2 price: 30);
		addOrder: (Order ask: 2 price: 40);
		addOrder: (Order ask: 1 price: 60);
		addOrder: (Order ask: 3 price: 60);												
		yourself

! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'DiegoCano 7/4/2012 11:19'!
testMarketPrice
	self should: [ orderBook1 marketPrice = 30 ]! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'FedericoBalaguer 7/6/2012 15:58'!
testTradingTickets
	self should: [ orderBook1 tradingTickets size = 3 ]! !

TestCase subclass: #PEMTestD1
	instanceVariableNames: 'fabricaOrdenes fabricaEmisores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinalTest-Ordenes1'!

!PEMTestD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 21:31'!
setUp
	fabricaOrdenes := FabricaOrdenesD1 new! !

!PEMTestD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:16'!
tearDown
	fabricaOrdenes := nil! !

!PEMTestD1 methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/5/2012 00:17'!
testDepuracionOrdenes
	"comment stating purpose of message"

	| temporary variable names |
! !

!PEMTestD1 methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/5/2012 00:15'!
testEmisores
	"comment stating purpose of message"

	| temporary variable names |
	! !

!PEMTestD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 21:16'!
testPrecioMercado
	"se crean todas las rdenes de compra y venta del juego de datos y se las agrega una a una al PEM; se pide al PEM que calcule el Precio de Mercado y se chequea que el valor devuelto coincida con el valor esperado."

	| pem precioMercadoEsperado precioMercadoCalculado |
	precioMercadoEsperado := 50.
	pem := PEM new.
	pem
		receiveOrder: fabricaOrdenes OC1;
		receiveOrder: fabricaOrdenes OV1.
	precioMercadoCalculado := pem marketPrice.
	self should: [ precioMercadoCalculado = precioMercadoEsperado ]! !

!PEMTestD1 methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/5/2012 00:15'!
testRecepcionOrdenes
	"comment stating purpose of message"

	| temporary variable names |
	! !

!PEMTestD1 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 17:13'!
testTrading
	"Una vez definido el precio de mercado se le solicita al PEM comercializar las unidades terica disponibles haciendo un match entre la ordenes de compra y venta. Se verifica los trading tickets generados correspondan con	las ordenes de compra y venta esperadas."

	| pem precioMercadoCalculado ticketsEsperados |
	pem := PEM new.
	precioMercadoCalculado := 30.
	Transcript clear.
	pem tradingTickets do: [ precioMercadoCalculado | Transcript show: precioMercadoCalculado ].
	self assert: ticketsEsperados = pem tradingTickets size! !
